// *****************************************************************************
// DGDraw.CPP : Opperates on all grDraw functions.
// *****************************************************************************
// DirectGlide2X                                                Official release
// Copyright (C) 1999                                           Khalid Shaikh
//                                                              Aaron Hilton
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Library General Public
//    License as published by the Free Software Foundation; either
//    version 2 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Library General Public License for more details.
//
//    You should have received a copy of the GNU Library General Public
//    License along with this library; if not, write to the Free
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Khalid Shaikh                                                   1255 Theberge
// kshaikh@ece.mcgill.ca                                        Brossard, Quebec
// http://www.angelic-coders.com/kshaikh (IE4 only)              Canada  J4W 2N2
//
// Please read the GNU CopyLeft License Agreement included with this code.
// Located in: LICENSE.TXT
// *****************************************************************************

#include "stdafx.h"

EXPORT void STD grDepthBiasLevel( FxI16 level )
{
	// TBI - add translation for WBuffering, and handle ZBuffering properly.
	pDTDState->fZBias = (float)level/(float)0xFFFF0;
	pGlideState->depth_bias = level;

	// TBI - reimpliment this to use a dynamic depth biasing function. (Reset between calls to grBufferSwap)

	// Let's just see if this biasing thing can work without really f@#king things up here.
	// (Normal range is 0->16, but Glide accepts everything 0 -> 0xFFFF)
	// TBI - must test this code out with other hardware, and if it works... I should
	// start doing Caps checks.
	//pDTDState->Framework.GetD3DDevice()->SetRenderState( D3DRENDERSTATE_ZBIAS, level );
	// Didn't work.. dang it. Using Z+addition trick instead.
}

EXPORT void STD grDepthBufferFunction( GrCmpFnc_t func )
{
	pGlideState->depth_func = func;
	pGlideState->DirtyFlags |= GlideState::EDirtyFlags::kDepth;

	switch( func )
	{
		case GR_CMP_NEVER:
			pDTDState->Framework.GetD3DDevice()->SetRenderState( D3DRENDERSTATE_ZFUNC, D3DCMP_NEVER );
			break;

		case GR_CMP_LESS:
			pDTDState->Framework.GetD3DDevice()->SetRenderState( D3DRENDERSTATE_ZFUNC, D3DCMP_LESS );
			break;

		case GR_CMP_EQUAL:
			pDTDState->Framework.GetD3DDevice()->SetRenderState( D3DRENDERSTATE_ZFUNC, D3DCMP_EQUAL );
			break;

		case GR_CMP_LEQUAL:
			pDTDState->Framework.GetD3DDevice()->SetRenderState( D3DRENDERSTATE_ZFUNC, D3DCMP_LESSEQUAL );
			break;

		case GR_CMP_GREATER:
			pDTDState->Framework.GetD3DDevice()->SetRenderState( D3DRENDERSTATE_ZFUNC, D3DCMP_GREATER );
			break;

		case GR_CMP_NOTEQUAL:
			pDTDState->Framework.GetD3DDevice()->SetRenderState( D3DRENDERSTATE_ZFUNC, D3DCMP_NOTEQUAL );
			break;

		case GR_CMP_GEQUAL:
			pDTDState->Framework.GetD3DDevice()->SetRenderState( D3DRENDERSTATE_ZFUNC, D3DCMP_GREATEREQUAL );
			break;

		case GR_CMP_ALWAYS:
			pDTDState->Framework.GetD3DDevice()->SetRenderState( D3DRENDERSTATE_ZFUNC, D3DCMP_ALWAYS );
			break;

		default:
			Assert(false); // Unsupported ZCompare function.
	}
}

// Determine how we should interpret the depth values.
EXPORT void STD grDepthBufferMode( GrDepthBufferMode_t mode )
{
	// Just remember the mode used.
	pGlideState->depth_mode = mode;
	pGlideState->DirtyFlags |= GlideState::EDirtyFlags::kDepth;
}

// Handle the depth buffering mask.
EXPORT void STD grDepthMask( FxBool enable )
{
	// Do the real Direct3D state change.
	if( enable )
	{
		pDTDState->Framework.GetD3DDevice()->SetRenderState( D3DRENDERSTATE_ZENABLE, D3DZB_TRUE );
	}
	else
	{
		pDTDState->Framework.GetD3DDevice()->SetRenderState( D3DRENDERSTATE_ZENABLE, D3DZB_FALSE );
	}

	// Remember this depth state.
	pGlideState->depth_mask = enable;
	pGlideState->DirtyFlags |= GlideState::EDirtyFlags::kDepth;
}
