// *****************************************************************************
// DGUtilityGeneral.CPP : Opperates on all utility (gu) functions.
// *****************************************************************************
// DirectGlide2X                                                Official release
// Copyright (C) 1999                                           Khalid Shaikh
//                                                              Aaron Hilton
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Library General Public
//    License as published by the Free Software Foundation; either
//    version 2 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Library General Public License for more details.
//
//    You should have received a copy of the GNU Library General Public
//    License along with this library; if not, write to the Free
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Khalid Shaikh                                                   1255 Theberge
// kshaikh@ece.mcgill.ca                                        Brossard, Quebec
// http://www.angelic-coders.com/kshaikh (IE4 only)              Canada  J4W 2N2
//
// Please read the GNU CopyLeft License Agreement included with this code.
// Located in: LICENSE.TXT
// *****************************************************************************

#include "stdafx.h"

//-------------------------------------------------------------
// 3Df Utility Functions.
//-------------------------------------------------------------
EXPORT FxBool STD gu3dfGetInfo( const char *filename, Gu3dfInfo *info )
{
	return FXFALSE;
}

EXPORT FxBool STD gu3dfLoad( const char *filename, Gu3dfInfo *info )
{
	return FXFALSE;
}

EXPORT int STD guEncodeRLE16( void *dst, void *src, FxU32 width, FxU32 height )
{
	return 0;
}

// High level alpha mode.
EXPORT void STD guAlphaSource( GrAlphaSource_t mode )
{
}

// High level color combine function.
EXPORT void STD guColorCombineFunction( GrColorCombineFnc_t func )
{
}

//-------------------------------------------------------------
// Draw Utility Functions.
//-------------------------------------------------------------
// Antialiased triangle, drawn with clip.
EXPORT void STD guAADrawTriangleWithClip( const GrVertex *va, const GrVertex *vb, const GrVertex *vc )
{
}

// Triangle, drawn with clip.
EXPORT void STD guDrawTriangleWithClip( const GrVertex *va, const GrVertex *vb, const GrVertex *vc )
{
}

// Draw a polygon using a vertex list format, with clipping.
EXPORT void STD guDrawPolygonVertexListWithClip( int nverts, const GrVertex vlist[] )
{
}

//-------------------------------------------------------------
// Fog Utility Functions.
//-------------------------------------------------------------
// Generate exponential fog table.
EXPORT void STD guFogGenerateExp( GrFog_t fogTable[GR_FOG_TABLE_SIZE], float density )
{
}

// Generate exponential squared fog table.
EXPORT void STD guFogGenerateExp2( GrFog_t fogTable[GR_FOG_TABLE_SIZE], float density )
{
}

// Generate a linear fog table.
EXPORT void STD guFogGenerateLinear( GrFog_t fogTable[GR_FOG_TABLE_SIZE], float nearZ, float farZ )
{
}

// Translate a fog table index to a W value. (Homogenous coordinate)
EXPORT float STD guFogTableIndexToW( int i )
{
	return (float)pow(2.0, 3.0 + ((double)(i>>2) / (8-(i&3))) );
}

//-------------------------------------------------------------
// Endian Swap Utility Functions.
//-------------------------------------------------------------
EXPORT FxU32 STD guEndianSwapWords( FxU32 value )
{
	return (value>>16)+(value<<16);
}

EXPORT FxU16 STD guEndianSwapBytes( FxU16 value )
{
	return (value>>8)+(value<<8);
}

