// *****************************************************************************
// DGlideGeneral.CPP : Opperates on all the general gr functions.
// *****************************************************************************
// DirectGlide2X                                                Official release
// Copyright (C) 1999                                           Khalid Shaikh
//                                                              Aaron Hilton
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Library General Public
//    License as published by the Free Software Foundation; either
//    version 2 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Library General Public License for more details.
//
//    You should have received a copy of the GNU Library General Public
//    License along with this library; if not, write to the Free
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Khalid Shaikh                                                   1255 Theberge
// kshaikh@ece.mcgill.ca                                        Brossard, Quebec
// http://www.angelic-coders.com/kshaikh (IE4 only)              Canada  J4W 2N2
//
// Please read the GNU CopyLeft License Agreement included with this code.
// Located in: LICENSE.TXT
// *****************************************************************************

#include "stdafx.h"

// Retrieve the current glide version information.
EXPORT void STD grGlideGetVersion( char version[80] )
{
	strcpy( version, "DirectGlide Version 2.6" );
}

// Store the status of the DirectGlide engine.
EXPORT void STD grGlideGetState( GrState *state )
{
	pGlideState->GetState( state );
}

// Reconfigure the DirectGlide engine with a previously stored state.
EXPORT void STD grGlideSetState( const GrState *state )
{
	pGlideState->SetState( state );
}

// First time preparation for the DirectGlide engine.
EXPORT void STD grGlideInit( void )
{
	// Allocate the state classes.
	pDTDState = new DTDState();
	pGlideState = new GlideState();
}

// Final shutdown for the DirectGlide engine.
EXPORT void STD grGlideShutdown( void )
{
	if(	pDTDState )
	{
		pDTDState->Toast();
		delete pDTDState;
		pDTDState = 0;
	}

	if( pGlideState )
	{
		delete pGlideState;
		pGlideState = 0;
	}
}
