//-------------------------------------------------------------------
//	File:		DTDTexture_AP_88.h
//	Created:	17/02/99 0:37AM
//	Author:		Aaron Hilton
//	Comments:   Implement the 8bitx8bit alpha embeded palettized texture format.
//-------------------------------------------------------------------
#ifndef __DTDTexture_AP_88_h_
#define __DTDTexture_AP_88_h_

#include "VTexture.h"

class DTDTexture_AP_88 : public VTexture
{
public:
	//-----------------------------------
	// Create the texture from a given (inclusive) address range.
	// Refer to pGlideState->pTexMemory for the texture memory.
	bool Create();

	// Announce that the texture needs updating (texture buffer became dirty).
	void Update();

	// Announce that the palette needs updating.
	// (Palette buffer is dirty, and we're about to draw!)
	void UpdatePal();

	// VTexture::Toast() takes care of destroying the DTD objects.
};


#endif // __DTDTexture_AP_88_h_
//-------------------------------------------------------------------
//	History:
//	$Log:$
//-------------------------------------------------------------------
