//-------------------------------------------------------------------
//	File:		DTDTexture_ARGB_4444_EmulateAP88.h
//	Created:	16/02/99 11:54PM
//	Author:		Aaron Hilton
//	Comments:	Implement the 8bit palettized texture format.
//-------------------------------------------------------------------
#ifndef __DTDTexture_ARGB_4444_EmulateAP88_h_
#define __DTDTexture_ARGB_4444_EmulateAP88_h_

#include "VTexture.h"

class DTDTexture_ARGB_4444_EmulateAP88 : public VTexture
{
public:
	//-----------------------------------
	// Create the texture from a given (inclusive) address range.
	// Refer to pGlideState->pTexMemory for the texture memory.
	bool Create();

	// Announce that the texture needs updating (texture buffer became dirty).
	void Update();

	// Announce that the palette needs updating.
	// (Palette buffer is dirty, and we're about to draw!)
	void UpdatePal();

	// We use an internal palette as reference, to detect changes.
	PALETTEENTRY m_PalEntries[256];

	// VTexture::Toast() takes care of destroying the DTD objects.
};


#endif // __DTDTexture_ARGB_4444_EmulateAP88_h_
//-------------------------------------------------------------------
//	History:
//	$Log:$
//-------------------------------------------------------------------
