//-------------------------------------------------------------------
//	File:		DTDTexture_P_8.h
//	Created:	16/02/99 11:54PM
//	Author:		Aaron Hilton
//	Comments:	Implement the 8bit palettized texture format.
//-------------------------------------------------------------------
#ifndef __DTDTexture_P_8_h_
#define __DTDTexture_P_8_h_

#include "VTexture.h"

class DTDTexture_P_8 : public VTexture
{
public:
	//-----------------------------------
	// Create the texture from a given (inclusive) address range.
	// Refer to pGlideState->pTexMemory for the texture memory.
	bool Create();

	// Announce that the texture needs updating (texture buffer became dirty).
	void Update();

	// Announce that the palette needs updating.
	// (Palette buffer is dirty, and we're about to draw!)
	void UpdatePal();

	// VTexture::Toast() takes care of destroying the DTD objects.
};


#endif // __DTDTexture_P_8_h_
//-------------------------------------------------------------------
//	History:
//	$Log:$
//-------------------------------------------------------------------
