//-------------------------------------------------------------------
// Debug - Debug system, and information.
// Standard debugging features.
//-------------------------------------------------------------------
#include "stdafx.h"
#include "Debug.h"

#include <crtdbg.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

unsigned long g_debugCode = 0;

#ifdef __DEBUG
	const char* g_debugString = 0;
	const char* g_debugFile = "None";
	long g_debugLineNumber = 0;

//-------------------------------------------
	void DebugOut(const char* szFormat, ...)
	{
		va_list argList;
		char szBuffer[kMaxDebugMessageLength];

		va_start(argList, szFormat);
		_vsnprintf(szBuffer, kMaxDebugMessageLength, szFormat, argList);
		va_end(argList);

		OutputDebugString(szBuffer);
	}
//-------------------------------------------
#endif

//-------------------------------------------------------------------
void VerifyMessage (long errStrIndex, const char* exprString, const char* file, long linenumber)
{
	// Copy our debug info to our local buffer.
	char szBuffer[kMaxDebugMessageLength];
	sprintf(szBuffer, "Assert Failed: %s\nIn: %s\nLine: %d", exprString, file, linenumber);

	// Display the error message.
	MessageBox(NULL, szBuffer, "Assertion", MB_OK | MB_ICONERROR | MB_TOPMOST | MB_SETFOREGROUND );
	_ASSERT(FALSE);		// Forced breakpoint, for debugging.
}
