//-------------------------------------------------------------------
//	File:		UniqueBlendState.h
//	Created:	25/02/99 2:02AM
//	Author:		Aaron Hilton
//	Comments:	Help identify unique glide blend states.
//-------------------------------------------------------------------
#ifndef __UniqueBlendState_h_
#define __UniqueBlendState_h_

class UniqueBlendState
{
	public:
	UniqueBlendState();
	bool IsEqual( UniqueBlendState* pState );
	void Print( FILE *f );

	// Hold the states in a linked list.
	UniqueBlendState *pNext;

	// Alpha blending.
	GrAlphaBlendFnc_t alpha_rgb_source;
	GrAlphaBlendFnc_t alpha_rgb_dest;
	GrAlphaBlendFnc_t alpha_alpha_source;
	GrAlphaBlendFnc_t alpha_alpha_dest;

	// Alpha combine processing.
	GrCombineFunction_t	alpha_func;
	GrCombineFactor_t	alpha_factor;
	GrCombineLocal_t	alpha_local;
	GrCombineOther_t	alpha_other;
	FxBool				alpha_invert;

	// Chromakey, in the alpha stage.
	GrCmpFnc_t	alpha_test_func;
	GrAlpha_t	alpha_test_value;

	// Chromakey, in the pixelFX stage.
	GrChromakeyMode_t	chroma_mode;
	GrColor_t			chroma_value;

	// Color combine processing.
	GrCombineFunction_t	color_func;
	GrCombineFactor_t	color_factor;
	GrCombineLocal_t	color_local;
	GrCombineOther_t	color_other;
	FxBool				color_invert;

	// Constant color value.
	GrColor_t color_value;
};



#endif // __UniqueBlendState_h_
//-------------------------------------------------------------------
//	History:
//	$Log:$
//-------------------------------------------------------------------
