//-------------------------------------------------------------------
//	File:		VTexture.cpp
//	Created:	14/02/99 3:07AM
//	Author:		Aaron Hilton
//	Comments:	An interface class which provides all the base
//				functionality to make the texture management work.
//-------------------------------------------------------------------
#include "stdafx.h"
#include "VTexture.h"

// Reset our variables of interest.
// TBI - should we do this initialization of the variables here, or should they be in Create()?
VTexture::VTexture()
{
	m_pPrev = m_pNext = 0;

	pSurface = 0;
	pTexture = 0;
	pPalette = 0;
	bPal = false;
}

// Create a null texture, with all the right info.
// Refer to pGlideState->pTexMemory for the texture memory.
bool VTexture::Create()
{
 	return true;
}

// Announce that the texture needs updating.
void VTexture::Update()
{
}

// Announce that the palette needs updating.
// (Palette buffer is dirty, and we're about to draw!)
void VTexture::UpdatePal()
{
}

// Toasts the texture from memory. (May be called multiple times)
void VTexture::Toast()
{
	if( pPalette )
	{
		pPalette->Release();
		pPalette = 0;
	}

	if( pTexture )
	{
		pTexture->Release();
		pTexture=0;
	}

	if( pSurface )
	{
		pSurface->Release();
		pSurface=0;
	}
}

//-----------------------------------
// Determine if the texture is identical to the one given in pInfo.
bool VTexture::IsEqual( GrTexInfo *pInfo )
{
	if(	( pInfo->smallLod == m_Info.smallLod ) &&
		( pInfo->largeLod == m_Info.largeLod ) &&
		( pInfo->aspectRatio == m_Info.aspectRatio ) &&
		( pInfo->format == m_Info.format ) )
	{ // All of the texture info is equal.
		return true;
	}

	// One of the texture info values are incompatible with this texture.
	return false;
}

//-------------------------------------------------------------------
//	History:
//	$Log:$
//-------------------------------------------------------------------
